--- /cygdrive/e/acs/software/src/XEmacs-build-2005-12-19/xemacs-21.4-2005-12-19/lisp/find-paths.el	2002-08-20 07:34:41.000000000 -0400
+++ /cygdrive/e/acs/xemacs-21.4-2005-12-20/lisp/find-paths.el	2005-12-20 15:53:57.938804800 -0500
@@ -108,7 +108,13 @@
    ;; in-place or windows-nt
    (and
     (paths-file-readable-directory-p (paths-construct-path (list directory "lisp")))
-    (paths-file-readable-directory-p (paths-construct-path (list directory "etc"))))))
+    (paths-file-readable-directory-p (paths-construct-path (list directory "etc"))))
+
+   ;; searching for a package root
+   (and
+    (paths-file-readable-directory-p (paths-construct-path (list directory "xemacs-packages")))
+    (paths-file-readable-directory-p (paths-construct-path (list directory "mule-packages")))
+    (paths-file-readable-directory-p (paths-construct-path (list directory "site-packages"))))))
 
 (defun paths-root-in-place-p (root)
   "Check if ROOT is an in-place installation root for XEmacs."
@@ -139,6 +145,22 @@
 	(and (paths-emacs-root-p maybe-root-2)
 	     maybe-root-2))))
 
+(defun paths-find-potential-package-root
+  (invocation-directory invocation-name)
+  "Find a possible root for the lisp package installation."
+  (let* ((executable-file-name (paths-chase-symlink
+				(concat invocation-directory
+					invocation-name)))
+	 (executable-directory (file-name-directory executable-file-name))
+	 (maybe-root-1 (file-name-as-directory
+			(paths-construct-path '(".." "..") executable-directory)))
+	 (maybe-root-2 (file-name-as-directory
+			(paths-construct-path '(".." ".." "..") executable-directory))))
+    (or (and (paths-emacs-root-p maybe-root-1)
+	     maybe-root-1)
+	(and (paths-emacs-root-p maybe-root-2)
+	     maybe-root-2))))
+
 (defun paths-construct-path (components &optional expand-directory)
   "Convert list of path components COMPONENTS into a path.
 If EXPAND-DIRECTORY is non-NIL, use it as a directory to feed
@@ -306,6 +328,14 @@
 	 (invocation-roots
 	  (and potential-invocation-root
 	       (list potential-invocation-root)))
+	 (potential-package-root
+	  (paths-find-potential-package-root invocation-directory invocation-name))
+	 (package-roots
+	  (and potential-package-root
+	       (list potential-package-root)))
+	 (combined-roots
+	  (paths-uniq-append invocation-roots
+			     package-roots))
 	 (potential-installation-roots
 	  (paths-uniq-append
 	   (and configure-exec-prefix-directory
@@ -316,7 +346,7 @@
 		       configure-prefix-directory)))))
 	 (installation-roots
 	  (paths-filter #'paths-emacs-root-p potential-installation-roots)))
-    (paths-uniq-append invocation-roots
+    (paths-uniq-append combined-roots
 		       installation-roots)))
 
 ;;; find-paths.el ends here







